﻿using System;
using System.Xml;
using System.Linq;

namespace ConsoleApp6
{
    class Program
    {
        private static string _ip;
        private static string nonce = "";
        private static DateTime noncedate = DateTime.Now;
        private static int _port = 433;
        private static string _scheme = "https";

        private static string xAssetsUsername = "admin";
        private static string xAssetsApiDb = "x7";
        private static string xAssetsHostname = "localhost"; 

        private static xAssets.WebService xAssetClient;

        static void Main(string[] args)
        {
            var xassetId = "1";    // recievedItem.xassets_item_id;
            var po_order_item_id = "99";

            if (xassetId != null)
            {
                var hash = InitiliaseXAssetClient();

                string[] arrayOfString = { "EDIT", xassetId.ToString() };
                
                var result = xAssetClient.WebCommandProcessorArray(
                        hash, xAssetsUsername, xAssetsApiDb, _ip,
                        "AssetXML", sArguments: arrayOfString, xAssetsHostname, _port, _scheme, ref nonce, ref noncedate);

                Console.WriteLine("Updating item " + xassetId + " in XAssets system (PO Order Item Id:" + /*recievedItem.*/po_order_item_id + ").");

                XmlDocument xmlDoc = new XmlDocument();
                xmlDoc.LoadXml(result);

                XmlNode node = xmlDoc.SelectSingleNode("/A_T/A_R/SID");
                if (node != null)
                {
                    node.InnerText = "2";   // ((int)XAssetItemStatus.InService).ToString(); // TODO
                }

                var updatedAsset = xAssetClient.WebSaveXML(hash, xAssetsUsername, xAssetsApiDb, _ip, xmlDoc.OuterXml, false, xAssetsHostname, _port, _scheme, ref nonce, ref noncedate);
                Console.WriteLine("Asset Id " + updatedAsset + " status has been updated in XAssets");

            }

            Console.WriteLine("Finished"); Console.ReadLine();

        }
        static string InitiliaseXAssetClient()
        {
            _ip = Array.FindAll(System.Net.Dns.GetHostEntry(String.Empty).AddressList,
                a => a.AddressFamily == System.Net.Sockets.AddressFamily.InterNetwork).FirstOrDefault().ToString();

            xAssetClient = new xAssets.WebService();
            string hash = xAssetClient.WebLogon("", "admin", "PASSWORDHERE", xAssetsApiDb, _ip, xAssetsHostname, _port, _scheme, ref nonce, ref noncedate);

            return hash;
        }
    }
}

